<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;
use App\Http\Models\ItempenerimaanbarangModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;
class ItempenerimaanbarangService extends BaseService
{
    /**
     ItempenerimaanbarangService constructor.
    */
    public function __construct()
    {
        parent::__construct();
        $this->model= new ItempenerimaanbarangModel();
    }

	/**
	*  index function that get all data from database by default
	*  @return array|static[]
	*/
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	*  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	*  @param array $input
	*  @return array
	*/
	public function paging($input)
	{
		$this->model->joinRelationItemId()->joinRelationPenerimaanBarangId()->getQuery()->select(["itempenerimaanbarang.id as id",
			"itemId.id as itemId",
			"penerimaanBarangId.poNumber as penerimaanBarangId",
			"itempenerimaanbarang.quantity as quantity",
			"itempenerimaanbarang.satuan as satuan"]);
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	*  get one raw row data from table by id
	*  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	*  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	*  and you want to take value like this $model->fieldname
	*  @param $id
	*  @return ItempenerimaanbarangModel
	*/
	public function show($id)
	{
		$model=$this->model->getQuery()->where("itempenerimaanbarang.id","=",$id)->first();
		return $model;
	}


	/**
	*  this is a base function for storing data you with transaction by default
	*  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	*  @param array $input
	*  @return ItempenerimaanbarangModel
	*  @throws \Exception
	*/
	public function store($input)
	{
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			$newInput = $this->getPrepare($input);
			if(! empty($newInput)) {
				foreach($newInput as $row) {
					$itemBrg = new ItempenerimaanbarangModel();
					$itemBrg->fill($row);
					if(! $itemBrg->save()) {
						throw new \Exception();
					}
				}
				return $this->model;
			}
		}
	}

	private function getPrepare($input) {
		$data = [];
		if(isset($input["itemID"]) && ! empty($input["itemID"])) {
			foreach($input["itemID"] as $idx => $value) {
				$data[] = [	
							"penerimaanBarangId" 	=> $input["receiptNumber"], 
							"itemId" 				=> $value, 
							"receiptDate" 			=> $input["tanggalPenerimaan"], 
							"quantity" 				=> $input["quantity"][$value], 
							"lotNumber" 			=> $input["lotNumber"][$value], 
							"lokasiId" 				=> $input["lokasiId"][$value],
							"status"				=> 0
				];
			}
		}
		return $data;
	}


	/**
	* this function will delete much data, in one action
	* the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	* you can remove this main alogorithm with your business requirement like soft delete or anything you want
	*  @param $ids
	*/
	public function delete($ids){
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	*  this is a base function for update and delete data by default.
	*  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	*  you can add multiple relation proses after update in this function 
	*  @param $id
	*  @param array $input 
	*  @return ItempenerimaanbarangModel
	*  @throws \Exception
	*/
	public function update($id, $input)
	{
		$itempenerimaanbarang = ItempenerimaanbarangModel::find($id);
		// $itempenerimaanbarang->fill($input);
		$itempenerimaanbarang->quantity = $input["quantity"];

		if(! $itempenerimaanbarang->save()){
			throw new \Exception();
		}
		return $itempenerimaanbarang;
	}


	/**
	*  this function will be confirting paging property into file excel
	*  the main library is base on excel spreadsheet library
	*  @param array $input
	*   @return array|static[]
	*/
	public function exportToExcel($input =array())
	{
		return $this->model->getQuery()->get();
	}


	public function showBasedOnPenerimaanbarang($request, $headerTransaction) {
		$auth = json_decode($request->session()->get('auth'));
		
		$model = $this->model->joinRelationItemId("itemId")->joinRelationLocation()->getQuery()
		->where("itempenerimaanbarang.penerimaanBarangId", "=", $headerTransaction->receiptNumber)
		->where("itemId.kapalId", "=", $headerTransaction->kapalId)
		// ->where("lokasiId.kapalId", "=", $headerTransaction->kapalId)
		->whereIn("itemId.type_id", $auth->arrCategory)
		->whereIn("itempenerimaanbarang.lokasiId", $auth->arrLokasi)
		->select([	"itempenerimaanbarang.id as id",
					"itemId.namaItem as namaItem",
					"itemId.part_number as partNumber",
					"itemId.deskripsi as deskripsi",
					"itemId.category as category",
					"itemId.UOM as UOM",
					"itempenerimaanbarang.quantity as quantity",
					"itempenerimaanbarang.lokasiId as lokasiId",
					"lokasiId.namaLokasi as namaLokasi",
					"itempenerimaanbarang.lotNumber as lotNumber"])->get();
		return $model;
	}

	public function getStokSupply($kapalId, $arrIDs, $dateStart, $dateEnd) {
		$model = $this->model->joinRelationPenerimaanBarangId()->getQuery()
		->where("penerimaanBarangId.kapalId", "=", $kapalId)
		->whereIn("itempenerimaanbarang.itemId", $arrIDs)
		->whereRaw('"penerimaanBarangId"."tanggalPenerimaan" BETWEEN  \'' . $dateStart . '\' AND \'' . $dateEnd . '\' ')
		->selectRaw(' SUM("itempenerimaanbarang"."quantity") AS "nItem", "itempenerimaanbarang"."itemId" ')
		->groupBy("itempenerimaanbarang.itemId")
		->get();

		$arrItems = [];
		foreach($model as $row) {
			$arrItems[$row->itemId] = $row->nItem;
		}

		return $arrItems;
	}

	public function updateQty($pbNumber, $itemID, $qty) {
		$itemPenerimaan = $this->model->getQuery()->where("penerimaanBarangId", "=", $pbNumber)->where("itemId", "=", $itemID)->first();
		if(! $itemPenerimaan){
			throw new \Exception();
		} else {
			$qty = $itemPenerimaan->quantity + $qty;
            if($qty < 0) { $qty = 0; }
			$this->update($itemPenerimaan->id, ["quantity" => $qty]);
		}		
	}



}